#include <bits/stdc++.h>

#include <utility>

using namespace std;

#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define ld long double
#define ckmin(a, b) a = min(a, b)
#define ckmax(a, b) a = max(a, b)
#define int long long

struct Point {
    int x, y;

    Point(int x, int y) : x(x), y(y) {}

    Point() {}

    int len2() {
        return x * x + y * y;
    }

    ld len() {
        return (ld) sqrt(len2());
    }
};

int vec(Point &a, Point &b) {
    return a.x * b.y - a.y * b.x;
}

int scal(Point &a, Point &b) {
    return a.x * b.x + a.y * b.y;
}

Point operator+(Point a, Point b) {
    return {a.x + b.x, a.y + b.y};
}

Point operator-(Point a) {
    return {-a.x, -a.y};
}

Point operator-(Point a, Point b) {
    return a + (-b);
}

vector<vector<Point>> triangles;
int n;

void solve3() {
    cout << n * (n - 1) * (n - 2) * (n - 3) / 4 / 3 / 2 << '\n';
    for (int i = 1; i <= n; ++i) {
        for (int j = i + 1; j <= n; ++j) {
            for (int k = j + 1; k <= n; ++k) {
                for (int q = k + 1; q <= n; ++q) {
                    cout << i << " " << j << " " << k << " " << q << '\n';
                }
            }
        }
    }
}

Point get(Point &a, Point &b) {
    return (b - a);
}

void solve4_5() {
    map<int, vector<int>> idx;
    for (int i = 0; i < n; ++i) {
        auto v1 = get(triangles[i][0], triangles[i][1]);
        auto v2 = get(triangles[i][1], triangles[i][2]);
        auto v3 = get(triangles[i][0], triangles[i][2]);
        int hyp = max({v1.len2(), v2.len2(), v3.len2()});
        idx[hyp].push_back(i);
    }

    vector<vector<int>> res;
    for (auto &t: idx) {
        auto v = t.second;
        for (int i = 0; i < (int) v.size(); ++i) {
            for (int j = i + 1; j < (int) v.size(); ++j) {
                for (int k = j + 1; k < (int) v.size(); ++k) {
                    for (int q = k + 1; q < (int) v.size(); ++q) {
                        res.push_back({v[i] + 1, v[j] + 1, v[k] + 1, v[q] + 1});
                        sort(all(res.back()));
                    }
                }
            }
        }
    }

    sort(all(res));
    res.erase(unique(all(res)), res.end());

    cout << res.size() << '\n';
    for (auto &t: res) {
        for (int x: t)cout << x << " ";
        cout << '\n';
    }
}

ld eps = 1e-14;

ld getAngle(Point p1, Point p2) {
    ld scal1 = p1.len() * p2.len();
    ld scalar = scal(p1, p2);
    ld cosx = scalar / scal1;
    return acos(cosx);
}

vector<vector<ld>> angles;
ld PI;

bool isPi(ld X) {
    return abs(X - PI) <= eps;
}

ld toGrad(ld x){
    return x * 180.0 / PI;
}
signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    PI = acos(-1);

    int t;
    cin >> t >> n;
    triangles.resize(n, vector<Point>(3));
    angles.resize(n);

    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < 3; ++j) {
            cin >> triangles[i][j].x >> triangles[i][j].y;
        }
        angles[i].push_back(getAngle(get(triangles[i][1], triangles[i][0]), get(triangles[i][2], triangles[i][0])));
        angles[i].push_back(getAngle(get(triangles[i][0], triangles[i][1]), get(triangles[i][2], triangles[i][1])));
        angles[i].push_back(getAngle(get(triangles[i][0], triangles[i][2]), get(triangles[i][1], triangles[i][2])));
    }


    if (false) {
        solve3();
    } else if (false) {
        solve4_5();
    } else {
        vector<vector<int>> res;
        for (int mid = 0; mid < n; ++mid) {
            for (int t1 = 0; t1 < n; ++t1) {
                for (int t2 = 0; t2 < n; ++t2) {
                    for (int t3 = 0; t3 < n; ++t3) {
                        set<int> vals;
                        vals.insert(t1);
                        vals.insert(t2);
                        vals.insert(t3);
                        vals.insert(mid);
                        if (vals.size() != 4)continue;

                        int siu1 = get(triangles[mid][0], triangles[mid][1]).len2();
                        int siu2 = get(triangles[mid][1], triangles[mid][2]).len2();
                        int siu3 = get(triangles[mid][2], triangles[mid][0]).len2();

                        for (int side1 = 0; side1 < 3; ++side1) {
                            for (int side2 = 0; side2 < 3; ++side2) {
                                for (int side3 = 0; side3 < 3; ++side3) {
                                    int SIU1 = get(triangles[t1][side1], triangles[t1][(side1 + 1) % 3]).len2();
                                    int SIU2 = get(triangles[t2][side2], triangles[t2][(side2 + 1) % 3]).len2();
                                    int SIU3 = get(triangles[t3][side3], triangles[t3][(side3 + 1) % 3]).len2();
                                    if (SIU1 == siu1 && SIU2 == siu2 && SIU3 == siu3) {
                                       vector<ld>ang1, ang2, ang3;
                                       ang1.push_back(angles[t1][side1]);
                                       ang1.push_back(angles[t1][(side1 + 1) % 3]);
                                       ang2.push_back(angles[t2][side2]);
                                       ang2.push_back(angles[t2][(side2 + 1) % 3]);
                                       ang3.push_back(angles[t3][side3]);
                                       ang3.push_back(angles[t3][(side3 + 1) % 3]);
                                       reverse(all(ang1));
//                                       reverse(all(ang2));
                                       reverse(all(ang3));
                                       ld a1 = ang1[0] + angles[mid][0] + ang3[1];
                                       ld a2 = ang3[0] + angles[mid][2] + ang2[0];
                                       ld a3 = ang2[1] + angles[mid][1] + ang1[1];
                                       if(isPi(a1) && isPi(a2) && isPi(a3)){
                                           res.push_back({mid + 1, t1 + 1, t2 + 1, t3 + 1});
                                           sort(all(res.back()));
                                       }
                                    }
                                }
                            }
                        }
                    }
                }
            }
        }

        sort(all(res));


        res.erase(unique(all(res)), res.end());

        cout << res.size() << '\n';
        for (auto &tt: res) {
            for (int x: tt)cout << x << " ";
            cout << '\n';
        }
    }
}