#include <bits/stdc++.h>

using namespace std;

#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define ld long double
#define ckmin(a, b) a = min(a, b)
#define ckmax(a, b) a = max(a, b)
#define int long long

struct H {
    int mod, x, n;
    vector<int> a, px, h;

    H(vector<int> &a, int mod, int x) : a(a), mod(mod), x(x) {}

    H() {}

    void build() {
        n = (int) a.size();
        px.resize(n + 1);
        h.resize(n + 1);
        px[0] = 1;
        for (int i = 1; i <= n; ++i)
            px[i] = (px[i - 1] * x) % mod;

        for (int i = 1; i <= n; ++i)
            h[i] = (h[i - 1] * x + a[i - 1]) % mod;
    }

    int getHash(int l, int r) {
        return ((h[r + 1] - h[l] * px[r - l + 1] % mod) % mod + mod) % mod;
    }
};

int n, m;
vector<int> a, b;

int rev_id(int i, int len) {
    return len - 1 - i;
}

void solve33() {
    bool bad = false;
    for (int i = 1; i < m; ++i) {
        if (b[i] != b[i - 1]) {
            bad = true;
        }
    }

    if (bad)return;

    int x = 127, mod = (int) 1e9;
    H h(a, mod, x);
    h.build();

    reverse(all(a));

    H rev(a, mod, x);
    rev.build();

    int len = 1;
    for (int i = 0; i < n; ++i) {
        int l = 0, r = n + 1;
        while (l + 1 < r) {
            int M = (l + r) / 2;
            if (2 * M + 1 > m || M > i || M > n - 1 - i ||
                h.getHash(i - M, i - 1) != rev.getHash(rev_id(i + M, n), rev_id(i + 1, n))) {
                r = M;
            } else {
                l = M;
            }
        }
        ckmax(len, l * 2 + 1);
    }

    for (int i = 1; i < n; ++i) {
        int l = 0, r = n + 1;
        while (l + 1 < r) {
            int M = (l + r) / 2;
            if (2 * M > m || M > i || M > (n - 1 - (i - 1)) ||
                h.getHash(i - M, i - 1) != rev.getHash(rev_id(i + M - 1, n), rev_id(i, n))) {
                r = M;
            } else {
                l = M;
            }
        }
        ckmax(len, l * 2);
    }
    cout << len << '\n';
    exit(0);
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cin >> n >> m;
    a.resize(n);
    b.resize(m);
    for (int &i: a) cin >> i;
    for (int &i: b) cin >> i;

    solve33();


}