#include <bits/stdc++.h>

using namespace std;

#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define ld long double
#define ckmax(a, b) a = max(a, b)
#define ckmin(a, b) a = min(a, b)
#define int long long

const int inf = 1e18;
int n, k;
vector<int> a;

void solveK0() {
    if (k != 0)return;
    int res = -inf;
    vector<int> pref(n);
    pref[0] = a[0];
    ckmax(res, a[0]);
    for (int i = 1; i < n; ++i) {
        pref[i] = max(0ll, pref[i - 1]) + a[i];
        ckmax(res, pref[i]);
    }
    cout << res;
    exit(0);
}

struct segment_tree {
    vector<int> a, dp, sum;
    int n;

    void build(int v, int l, int r) {
        if (l == r) {
            dp[v] = a[l];
            sum[v] = a[l];
        } else {
            int m = (l + r) / 2;
            build(v * 2, l, m);
            build(v * 2 + 1, m + 1, r);
            dp[v] = max(dp[v * 2], sum[v * 2] + dp[v * 2 + 1]);
            sum[v] = sum[v * 2] + sum[v * 2 + 1];
        }
    }

    segment_tree(vector<int> A) {
        n = (int) A.size();
        a.resize(n);
        for (int i = 0; i < n; ++i)a[i] = A[i];
        dp.resize(4 * n, -inf);
        sum.resize(4 * n, 0);
        build(1, 0, n - 1);
    }

    pair<int, int> getDP(int v, int tl, int tr, int l, int r) {
        if (l > tr || tl > r)return {-inf, 0};
        if (l <= tl && tr <= r)return {dp[v], sum[v]};
        else {
            int tm = (tl + tr) / 2;
            auto left = getDP(v * 2, tl, tm, l, r);
            auto right = getDP(v * 2 + 1, tm + 1, tr, l, r);
            pair<int, int> res = {0, 0};
            res.second = left.second + right.second;
            res.first = max(left.first, left.second + right.first);
            return res;
        }
    }

    pair<int, int> getDP(int l, int r) {
        if (l > r)return {-inf, 0};
        return getDP(1, 0, n - 1, l, r);
    }
};

int rev_id(int i) {
    return n - 1 - i;
}

void solveK1() {
    if (k != 1)return;

    int res = 0;

    vector<int> L(n, -1), R(n, n);
    stack<int> st;
    for (int i = 0; i < n; ++i) {
        while (!st.empty() && a[st.top()] <= a[i])st.pop();
        if (!st.empty())L[i] = st.top();
        st.push(i);
    }

    while (!st.empty())st.pop();

    for (int i = n - 1; i >= 0; --i) {
        while (!st.empty() && a[st.top()] <= a[i])st.pop();
        if (!st.empty())R[i] = st.top();
        st.push(i);
    }


    vector<int> ra(n);
    for (int i = 0; i < n; ++i)
        ra[n - 1 - i] = a[i];

    segment_tree norm(a), rev(ra);


    for (int i = 0; i < n; ++i) {
        int l = L[i] + 1, r = R[i] - 1;
        auto q1 = norm.getDP(i + 1, r);
        auto q2 = rev.getDP(rev_id(i - 1), rev_id(l));
        ckmax(res, max(0ll, q1.first) + max(0ll, q2.first));
    }
    cout << res;
    exit(0);
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cin >> n >> k;
    a.resize(n);
    for (int i = 0; i < n; ++i) cin >> a[i];

    solveK0();
    solveK1();

    int res = -inf;
    for (int l = 0; l < n; ++l) {
        multiset<int> s;
        int sum = 0;

        for (int r = l; r < min(n, l + 5000ll); ++r) {
            s.insert(a[r]);
            if (s.size() > k) {
                auto it = s.begin();
                sum += *it;
                s.erase(it);
            }
            if (r - l + 1 >= k)
                ckmax(res, sum);
        }
    }

    cout << res;
}